package net.java.dev.fwutil.demoapp;

import java.io.File;
import java.io.IOException;

/**
 * DemoApp jar-loader which loads the classes in fwutil.jar which is
 * included in the demoapp.jar. 
 * @author Fred
 *
 */
public class DemoAppLoader {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		System.out.println("Loading DemoApp jars ...");
		try {
			File tdir = new File(System.getProperty("java.io.tmpdir") + File.separator + SysJarLoader.TempDirName);
			if (!tdir.exists() && !tdir.mkdir()) throw new IOException("Could not create temp-dir " + tdir.getAbsolutePath());
			SysJarLoader.addJarResource("resources/fwutil.jar");
			DemoApp.main(args);
		} catch (Exception e) {
			System.err.println("Failed to load required resource(s) from executable jar.");
			e.printStackTrace();
		}

	}

}
