package net.java.dev.fwutil;

import java.awt.Component;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;

/** An example class that makes dates more readable in a table. */
public class TableCellDateRenderer extends DefaultTableCellRenderer {

	private static final long serialVersionUID = 2121024499022643500L;

	public static SimpleDateFormat dateTimeFormat = new SimpleDateFormat("dd/MM/yy HH:mm:ss");

	public Component getTableCellRendererComponent(final JTable table, final Object value,
			final boolean isSelected, final boolean hasFocus, final int rowIndex, final int colIndex) {

		if (isSelected || hasFocus) {
			setBackground(table.getSelectionBackground());
		} else {
			setBackground(table.getBackground());
		}
		setText(Util.space + dateTimeFormat.format((Date) value));
		return this;
	}
}
