package net.java.dev.fwutil.gui;

import java.awt.Component;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JMenu;
import javax.swing.JMenuItem;

import net.java.dev.fwutil.FontSelector;
import net.java.dev.fwutil.Labels;

/** Base View menu with Select font option.
 * @author Fred
 *
 */
public class BMView extends JMenu implements ActionListener {

	private static final long serialVersionUID = 6110242369587664493L;
	
	protected IMainWindow mainWindow;

	public BMView(IMainWindow mainWindow) {
		super(Labels.get("View"));
		this.mainWindow = mainWindow;
		setMnemonic(KeyEvent.VK_V);
		addMenuItems();
	}
	
	/** Override to add your own menu-items. */
	public void addMenuItems() {
	
		JMenuItem m;
		m = new JMenuItem(Labels.get(BMLabel.SelectFont));
		m.setMnemonic(KeyEvent.VK_F);
		m.setActionCommand(BMLabel.SelectFont);
		m.addActionListener(this);
		add(m);
		m = new JMenuItem(Labels.get(BMLabel.MemoryInfoTitle));
		m.setMnemonic(KeyEvent.VK_M);
		m.setActionCommand(BMLabel.MemoryInfoTitle);
		m.addActionListener(this);
		add(m);
	}

	
	/** Override to catch your own action events from menu items. */
	public void actionPerformed(ActionEvent ae) {
		
		final String ac = ae.getActionCommand();
		if (BMLabel.SelectFont == ac) {
			FontSelector.show((Frame)mainWindow);	
		} else if (BMLabel.MemoryInfoTitle == ac) {
			BMemInfo.show(mainWindow, (Component)mainWindow);
		}
	}
}
