package net.java.dev.fwutil.gui;

import javax.swing.JMenuBar;

/** Menubar with Base Menus File, View and Window. */
public class BMainMenu extends JMenuBar implements IMainMenu {

	private static final long serialVersionUID = -8693634146427159748L;
	
	protected BMFile fileMenu;
	protected BMainWindow mainWindow;
	
	/** Use when extending this class, set a value for fileMenu manually. */
	public BMainMenu() {
		super();
	}
	
	/** Sets mainWindow and calls addMenus() */
	public BMainMenu(BMainWindow mainWindow) {
		super();
		this.mainWindow = mainWindow;
		addMenus(mainWindow);
	}
	
	/** If you nullify this method to load your own menus, 
	 * set a value for fileMenu.
	 * @param mainWindow
	 */
	public void addMenus(BMainWindow mainWindow) {
		
		fileMenu = new BMFile(mainWindow);
		add(fileMenu);
		add(new BMView(mainWindow));
		add(new BMWindow(mainWindow));
	}
	
	public boolean isClearSettingsSelected() {
		return (fileMenu == null ? false : fileMenu.deleteSettingsSelected());
	}
}
