package net.java.dev.fwutil.pf.ui;

import java.awt.Component;

import javax.swing.JMenuBar;
import javax.swing.JSeparator;

import net.java.dev.fwutil.Labels;
import net.java.dev.fwutil.Log;
import net.java.dev.fwutil.Restartable;
import net.java.dev.fwutil.gui.BMainWindow;
import net.java.dev.fwutil.pf.DiskInfo;
import net.java.dev.fwutil.pf.ui.menu.MainMenu;
import net.java.dev.hvlayout.HVProps;

public class MainWindow extends BMainWindow {

	private static final long serialVersionUID = -6342150019014190700L;

	private BrowsePanel browsePanel;
	private DiskInfo diskInfo;

	public MainWindow(Restartable mainRestart, Component owner) {
		super(mainRestart, owner);
	}
	
	protected void buildWindow() {

		diskInfo = new DiskInfo();
		browsePanel = new BrowsePanel(diskInfo);
		mainPanel.add(browsePanel.getPanel());
		JSeparator separator = new JSeparator();
		HVProps.setSize(separator, 0, separator.getPreferredSize().height, false);
		HVProps.doNotGrowHeigth(separator);
		mainPanel.add(separator);
		statusBar = new MainStatusBar(browsePanel.getTable().getModel());
		statusBar.setText(Labels.get("Loading"));
		mainPanel.add(statusBar);
		imainMenu = new MainMenu(this, browsePanel);
		setJMenuBar((JMenuBar)imainMenu);
		Log.log("Browse panel added.");
	}
	
	public boolean closeAllowed() { return true;	}
}
