package net.java.dev.fwutil.pf.ui.menu;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.io.File;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

import net.java.dev.fwutil.Labels;
import net.java.dev.fwutil.Log;
import net.java.dev.fwutil.Settings;
//import net.java.dev.fwutil.UIMessages;
import net.java.dev.fwutil.pf.ui.BookmarkDialog;
import net.java.dev.fwutil.pf.ui.BrowseLocation;
import net.java.dev.fwutil.pf.ui.MainWindow;

public class MBookmarks extends JMenu implements ActionListener {
		
	private static final long serialVersionUID = -3598619754064701955L;
	private BrowseLocation browseLocation;
	private JMenuItem setBookMark;
	private JMenuItem[] bookmarks;
	private MainWindow mainWindow;

	public MBookmarks(final MainWindow mainWindow, final BrowseLocation browseLocation) {
		super(Labels.get("Bookmarks"));
		this.mainWindow = mainWindow;
		this.browseLocation = browseLocation;
		setMnemonic(KeyEvent.VK_B);
		JMenuItem mi = new JMenuItem(Labels.get("SetBookMark"));
		setBookMark = mi;
		mi.setMnemonic(KeyEvent.VK_S);
		mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_D, KeyEvent.ALT_DOWN_MASK));
		mi.addActionListener(this);
		add(mi);
		addSeparator();
		bookmarks = new JMenuItem[9];
		for (int i = 0; i < bookmarks.length; i++) {
			String bm = (String)Settings.get("PFBookmark" + (i + 1));
			if (bm == null) {
				bm = File.separator;
				Settings.put("PFBookmark" + (i + 1), bm);
			}
			mi = new JMenuItem((i + 1) + " - " + bm);
			mi.setMnemonic(KeyEvent.VK_1 + i);
			mi.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1 + i, KeyEvent.CTRL_DOWN_MASK));
			mi.addActionListener(this);
			bookmarks[i] = mi;
			add(mi);
		}
	}

	public void actionPerformed(ActionEvent e) {
		
		if (e.getSource() == setBookMark) {
			BookmarkDialog.show(mainWindow, browseLocation.getLastPathKey(), this);
		} else {
			int bmNumber = -1;
			int i = 0;
			while (bmNumber == -1 && i < bookmarks.length) {
				if (e.getSource() == bookmarks[i]) bmNumber = i + 1;
				i++;
			}
			if (bmNumber != -1) {
				String bm = (String)Settings.get("PFBookmark" + (bmNumber));
				Log.log("Bookmark " + bmNumber + " selected: " + bm);
				browseLocation.setBookMarkLocation(bm);
			}
		}
	}

	public void updateBookmarks() {
		
		for (int i = 0; i < bookmarks.length; i++) {
			String bm = (String)Settings.get("PFBookmark" + (i + 1));
			bookmarks[i].setText((i + 1) + " - " + bm);
		}		
	}
}
