package net.java.dev.fwutil.pf.ui.menu;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.KeyStroke;

import net.java.dev.fwutil.Labels;
import net.java.dev.fwutil.pf.OpenFile;
import net.java.dev.fwutil.pf.ui.table.FileTable;

public class MFileActions {
	
	public enum Type {OpenFile, EditFile, OpenCustom1, OpenCustom2, OpenShell}
	
	private FileTable fileTable;
	private AbstractAction openFile;
	private AbstractAction editFile;
	private AbstractAction custom1;
	private AbstractAction custom2;
	private AbstractAction openShell;
	
	public MFileActions(FileTable fileTable) {
		super();
		this.fileTable = fileTable;
		createActions();
	}
	
	public AbstractAction getAction(Type t) {
		
		AbstractAction a = null;
		if (t == Type.OpenFile) {
			a = openFile;
		} else if (t == Type.EditFile) {
			a = editFile;
		} else if (t == Type.OpenCustom1) {
			a = custom1;
		} else if (t == Type.OpenCustom2) {
			a = custom2;
		} else if (t == Type.OpenShell) {
			a = openShell;
		}
		return a;
	}
	
	@SuppressWarnings("serial")
	private void createActions() {
		
		openFile = new AbstractAction() {{
			putValue(Action.NAME, Labels.get("Open"));
			putValue(Action.ACTION_COMMAND_KEY, Type.OpenFile.name());
			KeyStroke ks = KeyStroke.getKeyStroke(KeyEvent.VK_O, KeyEvent.CTRL_DOWN_MASK);
			putValue(Action.ACCELERATOR_KEY, ks);
			putValue(Action.MNEMONIC_KEY, ks.getKeyCode());
		}
		public void actionPerformed(final ActionEvent ae) {
			OpenFile.openFile(fileTable.getSelectedFile());
		}};
		editFile = new AbstractAction() {{
			putValue(Action.NAME, Labels.get("Edit"));
			putValue(Action.ACTION_COMMAND_KEY, Type.EditFile.name());
			KeyStroke ks = KeyStroke.getKeyStroke(KeyEvent.VK_E, KeyEvent.CTRL_DOWN_MASK);
			putValue(Action.ACCELERATOR_KEY, ks);
			putValue(Action.MNEMONIC_KEY, ks.getKeyCode());
		}
		public void actionPerformed(final ActionEvent ae) {
			OpenFile.openFile(fileTable.getSelectedFile(), true);
		}};
		custom1 = new AbstractAction() {{
			putValue(Action.NAME, Labels.get("Custom1Name"));
			putValue(Action.ACTION_COMMAND_KEY, Type.OpenCustom1.name());
			KeyStroke ks = KeyStroke.getKeyStroke(KeyEvent.VK_W, KeyEvent.CTRL_DOWN_MASK);
			putValue(Action.ACCELERATOR_KEY, ks);
			putValue(Action.MNEMONIC_KEY, ks.getKeyCode());
		}
		public void actionPerformed(final ActionEvent ae) {
			OpenFile.customCmd1(fileTable.getSelectedFile());
		}};
		custom2 = new AbstractAction() {{
			putValue(Action.NAME, Labels.get("Custom2Name"));
			putValue(Action.ACTION_COMMAND_KEY, Type.OpenCustom2.name());
			KeyStroke ks = KeyStroke.getKeyStroke(KeyEvent.VK_M, KeyEvent.CTRL_DOWN_MASK);
			putValue(Action.ACCELERATOR_KEY, ks);
			putValue(Action.MNEMONIC_KEY, ks.getKeyCode());
		}
		public void actionPerformed(final ActionEvent ae) {
			OpenFile.customCmd2(fileTable.getSelectedFile());
		}};
		openShell = new AbstractAction() {{
			putValue(Action.NAME, Labels.get("OpenShell"));
			putValue(Action.ACTION_COMMAND_KEY, Type.OpenShell.name());
			KeyStroke ks = KeyStroke.getKeyStroke(KeyEvent.VK_S, KeyEvent.CTRL_DOWN_MASK);
			putValue(Action.ACCELERATOR_KEY, ks);
			putValue(Action.MNEMONIC_KEY, ks.getKeyCode());
		}
		public void actionPerformed(final ActionEvent ae) {
			OpenFile.openShell(fileTable.getSelectedFile());
		}};
	}
}
