package nl.intercommit.mario.tools.jbossmon;

import java.util.ArrayList;

import javax.swing.SortOrder;
import javax.swing.RowSorter.SortKey;
import javax.swing.table.TableRowSorter;

import net.java.dev.fwutil.MTable;
import net.java.dev.hvlayout.HVProps;
import nl.intercommit.mario.tools.MarioContext;

public class ServerQueueTable extends MTable {

	private static final long serialVersionUID = -3779923231327056573L;
	private final ServerQueueMon monitor;

	public ServerQueueTable(final MarioContext mc, final JbServerMon smon) {
		super("QueueTable:" + smon.getServerURL());
		monitor = new ServerQueueMon(mc, smon);
		setModel(monitor);
		setRowSorter(new TableRowSorter<ServerQueueMon>(monitor));
		applyUIProps();
	}

	public ServerQueueMon getMonitor() {
		return monitor;
	}
	
	protected void setDefaultUIProps() {
		// Queue name
		getColumnModel().getColumn(0).setPreferredWidth(HVProps.defaultButtonWidth * 2);
		// Msgs on queue
		getColumnModel().getColumn(1).setPreferredWidth(HVProps.defaultButtonWidth);
		// Peak msgs on queue
		getColumnModel().getColumn(2).setPreferredWidth(HVProps.defaultButtonWidth);
		for (int i = 3; i < getColumnModel().getColumnCount(); i++) {
			getColumnModel().getColumn(i).setPreferredWidth(HVProps.defaultButtonWidth / 2);
		}
		// Total messages
		getColumnModel().getColumn(5).setPreferredWidth(HVProps.defaultButtonWidth);
		ArrayList<SortKey> skl = new ArrayList<SortKey>();
		skl.add(new SortKey(0, SortOrder.ASCENDING));
		getRowSorter().setSortKeys(skl);
	}

	public String getSelectedQueue() {

		String queueName = null;
		if (getSelectedRow() > -1) {
			return ((String)getValueAt(getSelectedRow(), 0));
		}
		return queueName;
	}

	public void dispose() {
		monitor.dispose();
		super.dispose();
	}
}
